/* axdialbrain.h
 *
 * Copyright (C) 2001 RedHat, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */
/*
 * Modified for SIKIGAMI 2001,2002 Axe,Inc.
 */

#ifndef __AXDIALBRAIN_H__
#define __AXDIALBRAIN_H__

#include <termios.h>

#include "axpipe.h"

enum
{
    TOK_WORD = 0,
    TOK_NUMBER,
    TOK_PUNCT
};

typedef struct _BrainToken BrainToken;
struct _BrainToken
/***************/
{
    int	type;
    char *		tok_str;
    char		tok_char;
    BrainToken *	next;
};

typedef struct _AxDialer		AxDialer;
typedef	struct _AxDialBrain AxDialBrain;

struct	_AxDialBrain
{
    AxDialer *		dialer;

    int			sent_login;
    int			prompt_tries;
    char *	prompt_response;
};

extern	void		AxDialBrain_init( AxDialBrain * );
extern	void		AxDialBrain_init_valued( AxDialBrain *, AxDialer * );
extern	void		AxDialBrain_clear( AxDialBrain * );
extern	void		AxDialBrain_reset( AxDialBrain * );

extern	char *	AxDialBrain_guess_menu( AxDialBrain *, char * );
extern	char *	AxDialBrain_check_prompt( AxDialBrain *, char * );
extern	int			AxDialBrain_is_prompt( AxDialBrain *, char *, char *, int );
extern	int			AxDialBrain_is_login_prompt( AxDialBrain *, char * );
extern	int		  AxDialBrain_is_password_prompt( AxDialBrain *, char * );
extern	int			AxDialBrain_is_welcome_msg( AxDialBrain *, char * );

extern	BrainToken * AxDialBrain_tokenize( AxDialBrain * brain, char *, char * );
extern	BrainToken * AxDialBrain_tokenized( AxDialBrain *, char * );

extern	void		AxDialBrain_token_list_done(AxDialBrain*,BrainToken*);
extern	void		AxDialBrain_guess_menu_gets(AxDialBrain*,BrainToken*);
extern	void		AxDialBrain_set_prompt_response( AxDialBrain*,char*);

#endif
