/* axmodemscan.h
 *
 * Copyright (C) 2001 RedHat, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 */
/*
 * Modified for SIKIGAMI 2001,2002 Axe,Inc.
 */

#ifndef __AXMODEMSCAN_H__
#define __AXMODEMSCAN_H__

#include "axmodem.h"
#include "glib.h"

enum {
		AxModemScan_Startup=0,
		AxModemScan_AT,
		AxModemScan_ATZ,
		AxModemScan_ATS0, 
		AxModemScan_Carrier,
		AxModemScan_DTR,
		AxModemScan_FastDial,
		AxModemScan_FCLASS,
		AxModemScan_GetIdent,
		AxModemScan_BaudStep,
		AxModemScan_Reinit,
		AxModemScan_Done,
		AxModemScan_NUM_STAGES
};
enum {
		AxModemScan_Fail = -1,
		AxModemScan_Unknown = 0,
		AxModemScan_Worked = 1,
		AxModemScan_Test
};

typedef struct _AxModemScan AxModemScan;

struct _AxModemScan
{
    int stage;
    int status[ AxModemScan_NUM_STAGES];
    
    char * file;
    char * identifier;
    int baud, tries;
    AxModem *modem;
    int broken;
};

extern	void	AxModemScan_init_valude(AxModemScan*,char*);
extern	void	AxModemScan_clear(AxModemScan*);
extern	int		AxModemScan_isok(AxModemScan*);
extern	int		AxModemScan_isdone(AxModemScan*);
extern	int		AxModemScan_get_stage(AxModemScan*);
extern	char *AxModemScan_initstr(AxModemScan*);
extern	void	AxModemScan_execute(AxModemScan*);
extern	char *AxModemScan_filename(AxModemScan*);
extern	int		AxModemScan_maxbaud( AxModemScan*);
extern	int		AxModemScan_doresult(AxModemScan*,char *,int);
extern	size_t	AxModemScan_coagulate(AxModemScan*,char*,size_t,int);
extern	char *AxModemScan_is_isdn(AxModemScan*);

typedef struct _AxModemScanList AxModemScanList;

struct _AxModemScanList {
		GSList	*list;
	  int			thisline;
	  int			printed;
};

extern void		AxModemScanList_init( AxModemScanList * );
extern void		AxModemScanList_clear( AxModemScanList * );
extern void		AxModemScanList_setup( AxModemScanList * );
extern void		AxModemScanList_shutdown( AxModemScanList * );
extern void		AxModemScanList_execute( AxModemScanList * );
extern int		AxModemScanList_isdone( AxModemScanList * );

#endif
