/* axstream.h
 *
 * Copyright (C) 2001 RedHat, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */
/*
 * Modified for SIKIGAMI 2001,2002 Axe,Inc.
 */

#ifndef __AXSTREAM_H__
#define __AXSTREAM_H__

#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

typedef struct _SelectInfo SelectInfo;
struct _SelectInfo {
	  fd_set read, write, except;
	  int readable, writable, isexception;
	  int max_fd;
	  time_t msec_timeout;
};

typedef	struct _AxStream AxStream;
struct _AxStream {
	int		fd;
	int		errnum;
};

extern	void	AxStream_init( AxStream * );
extern	void	AxStream_init_valued( AxStream *, int );
extern	void	AxStream_clear( AxStream * );
extern	void	AxStream_close( AxStream * );
extern	void	AxStream_execute( AxStream * );
extern	int		AxStream_getfd( AxStream * );
extern	int		AxStream_isok( AxStream * );
extern	size_t	AxStream_read(  AxStream *, void *, size_t );
extern	size_t	AxStream_write( AxStream *, void *, size_t );
extern	void	AxStream_drain( AxStream * );
extern	void	AxStream_flush( AxStream *, time_t ); 
extern	int		AxStream_select( AxStream* , time_t, int, int, int );
extern	int		AxStream_select_setup(AxStream*,SelectInfo*);
extern	int		AxStream_test_set(AxStream*,SelectInfo*);
extern	size_t	AxStream_print( AxStream*,char *);
extern	size_t	AxStream_print1( AxStream*,char *, char *);
extern	void	AxStream_seterr( AxStream*,int);
extern	void	AxStream_seterrstr( AxStream*,char*);
extern	int		AxStream_geterr(AxStream*);
extern	char *AxStream_errstr(AxStream*);

#endif
