/* mainwin.h
 *
 * Copyright (C) 2001 RedHat, Inc.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */
/*
 * Modified for SIKIGAMI 2001,2002 Axe,Inc.
 */

#ifndef __MAINWIN_H__
#define __MAINWIN_H__

#include <config.h>
#include <gnome.h>
#include "account.h"
#include "modem.h"

GtkWidget* sgdial_mainwin_new(void);
void       sgdial_set_tooltip(GtkWidget* w, const gchar* tip);

void       sgdial_editable_enters   (GtkWindow* win,
                                  GtkEditable * editable);

/* mainwin owns any accounts added */
void       sgdial_mainwin_add_account(GtkWidget* w, Account* a);
void       sgdial_mainwin_add_modem (GtkWidget* w, Modem *modem);
/* destroys the account object */
void       sgdial_mainwin_remove_account(GtkWidget* w, Account* a);
void       sgdial_mainwin_account_changed(GtkWidget* w, Account* a);
/* Reload status of each account */
void       sgdial_mainwin_update_accounts(GtkWidget* w);
void       sgdial_mainwin_modem_changed(GtkWidget* w, Modem *modem);

/* Sets up the initial druid. */
void       initial_add_window (GtkWidget *mainwin);

void       sgdial_exit(int status);

#endif

