/* netreport.c
 *
 * Copyright (C) 2001 RedHat, Inc.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 */
/*
 * Modified for SIKIGAMI 2001,2002 Axe,Inc.
 */

#include "netreport.h"
#include "forkexec.h"

/* Subscribe to netreport events.
 * This MUST be called from the process that wants to receive SIGIO
 * signals when network status changes happen.
 * Returns 0 on success, non-zero on failure.
 */
int
netreport_subscribe() {
    return fork_exec(1, "/sbin/netreport", NULL);
}

/* Unsubscribe to netreport events.
 * This MUST be called from the smae process that called _subscribe().
 * Returns 0 on success, non-zero on failure.
 */
int
netreport_unsubscribe() {
    return fork_exec(1, "/sbin/netreport", "-r");
}
