/* sgdruid.c
 * Copyright (C) 1999 Red Hat, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
/*
 * modified 2002 Axe, Inc.
 */

#include <config.h>

#include <gnome.h>
#include "sgdruid.h"
enum {
	CANCEL,
	LAST_SIGNAL
};
static void gnome_sgdruid_init		(GnomeSgDruid		 *druid);
static void gnome_sgdruid_class_init	(GnomeSgDruidClass	 *klass);
static void gnome_sgdruid_size_allocate   (GtkWidget               *widget,
					 GtkAllocation           *allocation);

static GnomeDruidClass *parent_class = NULL;


GtkType
gnome_sgdruid_get_type (void)
{
  static GtkType druid_type = 0;

  if (!druid_type)
    {
      static const GtkTypeInfo druid_info =
      {
        "GnomeSgDruid",
        sizeof (GnomeSgDruid),
        sizeof (GnomeSgDruidClass),
        (GtkClassInitFunc) gnome_sgdruid_class_init,
        (GtkObjectInitFunc) gnome_sgdruid_init,
        /* reserved_1 */ NULL,
        /* reserved_2 */ NULL,
        (GtkClassInitFunc) NULL,
      };

      druid_type = gtk_type_unique (gnome_druid_get_type (), &druid_info);
    }

  return druid_type;
}

static void
gnome_sgdruid_class_init (GnomeSgDruidClass *klass)
{
	GtkObjectClass *object_class;
	GtkWidgetClass *widget_class;
	GnomeDruidClass *druid_class;

	object_class = (GtkObjectClass*) klass;
	widget_class = (GtkWidgetClass*) klass;
	druid_class = (GnomeDruidClass*) klass;
	parent_class = gtk_type_class ( gnome_druid_get_type());

	widget_class->size_allocate = gnome_sgdruid_size_allocate;
}

static void
gnome_sgdruid_init (GnomeSgDruid *druid)
{
#if 0
	GTK_WIDGET_SET_FLAGS (GTK_WIDGET (druid), GTK_NO_WINDOW);

	druid->back = gtk_button_new_with_label(_("Back"));
	GTK_WIDGET_SET_FLAGS (druid->back, GTK_CAN_DEFAULT);
	druid->next = gtk_button_new_with_label(_("Next"));
	GTK_WIDGET_SET_FLAGS (druid->next, GTK_CAN_DEFAULT);
	druid->cancel = gtk_button_new_with_label(_("Cancel"));
	GTK_WIDGET_SET_FLAGS (druid->cancel, GTK_CAN_DEFAULT);
	druid->finish = gtk_button_new_with_label(_("Finish"));
	GTK_WIDGET_SET_FLAGS (druid->finish, GTK_CAN_DEFAULT);

	gtk_widget_set_parent (druid->back, GTK_WIDGET (druid));
	gtk_widget_set_parent (druid->next, GTK_WIDGET (druid));
	gtk_widget_set_parent (druid->cancel, GTK_WIDGET (druid));
	gtk_widget_set_parent (druid->finish, GTK_WIDGET (druid));
	gtk_widget_show (druid->back);
	gtk_widget_show (druid->next);
	gtk_widget_show (druid->cancel);
	gtk_widget_show (druid->finish);

	druid->current = NULL;
	druid->children = NULL;
	druid->show_finish = FALSE;

	gtk_signal_connect (GTK_OBJECT (druid->back),
			    "clicked",
			    gnome_sgdruid_back_callback,
			    druid);
	gtk_signal_connect (GTK_OBJECT (druid->next),
			    "clicked",
			    gnome_sgdruid_next_callback,
			    druid);
	gtk_signal_connect (GTK_OBJECT (druid->cancel),
			    "clicked",
			    gnome_sgdruid_cancel_callback,
			    druid);
	gtk_signal_connect (GTK_OBJECT (druid->finish),
			    "clicked",
			    gnome_sgdruid_next_callback,
			    druid);
#else
#endif
}


static void
gnome_sgdruid_size_allocate (GtkWidget *widget,
			   GtkAllocation *allocation)
{
	GnomeDruid *druid;
	GtkAllocation child_allocation;
	gint button_height;
	GList *list;
	
	g_return_if_fail (widget != NULL);
	g_return_if_fail (GNOME_IS_SGDRUID (widget));

	druid = GNOME_DRUID (widget);
	widget->allocation = *allocation;

		
		

	/* deal with the buttons */
	child_allocation.width = child_allocation.height = 0;
	child_allocation.width = druid->back->requisition.width;
	child_allocation.height = druid->back->requisition.height;
	child_allocation.width = MAX (child_allocation.width,
			    druid->next->requisition.width);
	child_allocation.height = MAX (child_allocation.height,
			    druid->next->requisition.height);
	child_allocation.width = MAX (child_allocation.width,
			    druid->cancel->requisition.width);
	child_allocation.height = MAX (child_allocation.height,
			    druid->cancel->requisition.height);

	child_allocation.height += GNOME_PAD_SMALL;
	button_height = child_allocation.height;
//--	child_allocation.width += 2 * GNOME_PAD_SMALL;

child_allocation.width = 110;

	child_allocation.x = allocation->x + allocation->width - GNOME_PAD_SMALL - child_allocation.width;
	child_allocation.y = allocation->y + allocation->height - GNOME_PAD_SMALL - child_allocation.height;
	gtk_widget_size_allocate (druid->cancel, &child_allocation);
	child_allocation.width -= 50;
//	child_allocation.x -= (child_allocation.width * 5 / 4);
	child_allocation.x -= child_allocation.width - 2;
	gtk_widget_size_allocate (druid->next, &child_allocation);
	gtk_widget_size_allocate (druid->finish, &child_allocation);
//	child_allocation.x -= (GNOME_PAD_SMALL + child_allocation.width);
	child_allocation.x -= child_allocation.width - 2;
	gtk_widget_size_allocate (druid->back, &child_allocation);

	/* Put up the GnomeDruidPage */
	child_allocation.x = allocation->x + GNOME_PAD_SMALL;
	child_allocation.y = allocation->y + GNOME_PAD_SMALL;
	child_allocation.width =
		((allocation->width - 2* GNOME_PAD_SMALL) > 0) ?
		(allocation->width - 2* GNOME_PAD_SMALL):0;
	child_allocation.height =
		((allocation->height - 3 * GNOME_PAD_SMALL - button_height) > 0) ?
		(allocation->height - 3 * GNOME_PAD_SMALL - button_height):0;

	for (list = druid->children; list; list=list->next) {
		if (GTK_WIDGET_VISIBLE (list->data)) {
			gtk_widget_size_allocate (GTK_WIDGET (list->data), &child_allocation);
		}
	}
}

/* Public Functions */
GtkWidget *
gnome_sgdruid_new (void)
{
	return GTK_WIDGET (gtk_type_new (gnome_sgdruid_get_type ()));
}
